/* 
 * Programa para armazenar informacoes sobre livros
 * Moacir A Ponti - ICMC/USP 2020
 * > demonstrando como utilizar alocacao dinamica
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// NAO é uma variável!
// é como se (struct livro) fosse um novo tipo
typedef struct livro {
	char titulo[120]; 
	unsigned short ano;
	char autor[60];
	float preco;
} LIVRO;


void entrada_livro(LIVRO* eliv) {
	
	//   eliv  é do tipo LIVRO*  : um endereco de um struct livro
	// (*eliv) é do tipo LIVRO   : tenho acesso aos campos da struct
	// 					(*eliv).titulo
	// eliv->titulo        
	// (*eliv).titulo     ->   (*end).

	printf("Titulo: ");
	fgets( (*eliv).titulo , 120, stdin); // 120 bytes - 1 
       	(*eliv).titulo[ strlen((*eliv).titulo)-1 ] = '\0';	

	printf("Ano: ");
	scanf("%hu", &eliv->ano);
	getchar(); // consome o \n antes do fgets

	printf("Autor: ");
	fgets(eliv->autor, 120, stdin); // 120 bytes - 1 
       	eliv->autor[ strlen(eliv->autor)-1 ] = '\0';

	printf("Preco: ");
	scanf("%f", &eliv->preco); 
}


void exibe_livro(const LIVRO* eliv, FILE* stream) {

	fprintf(stream, "\nLIVRO\n");	
	fprintf(stream, "Titulo: %s\n", eliv->titulo);;
	fprintf(stream, "Ano: %hu\n", eliv->ano);
	fprintf(stream, "Autor: %s\n", eliv->autor);
	fprintf(stream, "Preco: %.2f\n", eliv->preco);
}

int main (void) {
	
	LIVRO* lista = NULL; // endereco
	int n_livros = 0;
	int qtd;

	FILE* fb = fopen("livros.dat", "r+");
	if (fb == NULL) {
		printf("Erro ao abrir arquivo livros.dat, criando um novo\n");

		fb = fopen("livros.dat", "w+");
		if (fb == NULL) {
			printf("Erro ao criar arquivo livros.dat\n");
			exit(1);
		}
	} else {
		// os primeiros 4 bytes sao um inteiro contendo quantos livros há no arquivo
		fread(&n_livros, sizeof(int), 1, fb);
		printf("Há %d livros no arquivo\n", n_livros);
		if (n_livros > 0) {

			lista = malloc( n_livros * sizeof(LIVRO) );

			int n_livroslidos = fread(lista, sizeof(LIVRO), n_livros, fb);
			printf("Livros lidos do arquivo = %d\n", n_livroslidos);

			for (int i = 0; i < n_livroslidos; i++) {
				exibe_livro(&lista[i], stdout);
			}
		}
	}


	do {
		printf("Alocar quantos novos livros? ");
		scanf("%d", &qtd);
		n_livros += qtd;

		lista = realloc(lista, n_livros * sizeof(LIVRO));

		for (int i = (n_livros-qtd); i < n_livros; i++) {
			getchar();
			printf("Livro %d\n", i+1);
			entrada_livro(&lista[i]);
		}

		for (int i = 0; i < n_livros; i++) {
			exibe_livro(&lista[i], stdout);
		}
	} while (qtd > 0);
	
	fseek(fb, 0L, SEEK_SET);
	fwrite(&n_livros, sizeof(int), 1, fb); // primeiro inteiro indica quantos livros
	fwrite(lista, sizeof(LIVRO), n_livros, fb);
	fclose(fb);

	free(lista);


	return 0;
}
